##!/usr/bin/env python
# -*- coding: utf-8 -*-

import gtk, gtk.glade, os, ConfigParser

# i18n
domaine = 'astuces'
import gettext,gtk,sys
import pdb

# i18n
domaine = 'astuces'
local_path = os.path.abspath(os.path.join(os.environ['NOTECALC_DIR'], 'locale'))
#pour glade
gtk.glade.bindtextdomain(domaine, local_path)
gtk.glade.textdomain(domaine)
#recup langue systeme
import locale
lang = locale.getdefaultlocale()[0][:2]
try:
    cur_lang = gettext.translation(domaine, localedir=local_path, languages=[lang])
    cur_lang.install()
except IOError:
    gettext.install(domaine)


class astuces:
    def __init__(self, aff_on_run = False):
        print "astuces"

        #Cagrgement config
        self.config = ConfigParser.ConfigParser()
        self.config.read(os.path.join(os.environ['NOTECALC_USERDIR'],'astuces.ini'))


        #liste de astuces
        self.list_astuces = [
                _('astuce : translator, write a introduction'),
                _('astuce : translator, explain comments'),
                _('astuce : translator, explain calculations multi-lines'),
                _('astuce : translator, explain titles'),
                _('astuce : translator, explain units'),
                _('astuce : translator, explain exponents and indices')
            ]

        self.total = len(self.list_astuces)

        if self.config.getboolean('astuces','aff_on_run') or not aff_on_run :
            '''Si l'interface est lancer au démarrage et que l'option d'affichage au lancement est activée
            ou que c'est un lancement "normal"
            → lancement gui'''
            self.gui = gtk.glade.XML(os.path.join(os.environ['NOTECALC_DIR'],'gui','astuces.glade'))

            dictionnaire_temporaire = {}
            for iteration in dir(self.__class__):
                dictionnaire_temporaire[iteration]= getattr(self,iteration)

            self.gui.signal_autoconnect(dictionnaire_temporaire)

            #bt affichage au lancement
            self.gui.get_widget('checkbutton_affOnRun').set_active(self.config.getboolean('astuces','aff_on_run'))

            #Affichage de l'astuce
            self.number = self.config.getint('astuces','number')
            self.number = self.aff_astuce(self.number)


    def aff_astuce (self,number) :
        if number > self.total - 1 :
            number = 0
        elif number < 0 :
            number = self.total - 1
        self.gui.get_widget('label_astuce').set_markup(self.list_astuces[number])
        self.gui.get_widget('label_astuce').set_line_wrap(True)
        self.gui.get_widget('label_position_astuce').set_text(_('astuce %s / %s')%(number + 1,self.total))
        return number


    def on_bt_prevAstuce_clicked(self,event):
        print "astuce precédent"
        self.number -= 1
        self.number = self.aff_astuce(self.number)


    def on_bt_nextAstuce_clicked(self,event):
        print "astuce suivant"
        self.number += 1
        self.number = self.aff_astuce(self.number)


    def on_bt_closeAstuce_clicked(self,event):
        self.config.set('astuces','aff_on_run',self.gui.get_widget('checkbutton_affOnRun').get_active())
        self.config.set('astuces','number',self.number + 1)
        self.config.write(open(os.path.join(os.environ['NOTECALC_USERDIR'],'astuces.ini'),'w'))
        self.gui.get_widget('astuces').destroy()
        return True



if __name__ == '__main__':
    #astuces()
    import notecalc
