﻿##!/usr/bin/env python

# This file is a part of NoteCalc.
#
# Auteur  : Jonas Fourquier (http://jonas.tuxfamily.org)
# Licence : GNU GPL

import os, gtk, pdb, sys, gobject

class plugins:

    def __init__(self,dicoInfo,listCalc):
        #Affichage
        print "*** Export ***"
        self.listCalc = listCalc
        self.dicoInfo = dicoInfo

    def gui(self):
        import gtk.glade

        self.gui = gtk.glade.XML(os.path.join(os.environ['NOTECALC_DIR'],'gui','plugins.glade'))
        dictionnaire_temporaire = {}
        for iteration in dir(self.__class__):
            dictionnaire_temporaire[iteration]= getattr(self,iteration)
        self.gui.signal_autoconnect(dictionnaire_temporaire)

        self.listPlugins = listViewPlugins(self.gui.get_widget('listPlugins'))

        for plugin in self.loadPlugins():
            self.listPlugins.store.append(plugin)

        #Champ text
        self.title =    self.gui.get_widget('title')
        self.author =   self.gui.get_widget('author')
        self.version =  self.gui.get_widget('version')
        self.desc =     self.gui.get_widget('desc')
        self.depends =  self.gui.get_widget('depends')
        self.textInfo = self.gui.get_widget('textInfo')

        self.infoWindow = self.gui.get_widget('info')

        #bouton
        self.infoButton = self.gui.get_widget('infoButton')
        self.prefButton = self.gui.get_widget('prefButton')

        dialog = gtk.Dialog(
                title="création du fichier source LaTeX", parent=None, flags=0, buttons=None
            )


    #Boutons
    def on_listPlugins_cursor_changed(self,object):
        '''quand on bouge dans la liste des plugins'''
        print "selection d'un autre plugin"

        selection = object.get_selection()
        (listStore, self.path) = selection.get_selected_rows()

        #affichage dans le panneau latéral
        self.title.set_text('<big>%s</big>'%listStore[self.path[0]][0])
        self.title.set_use_markup(True)
        self.author.set_text(str(listStore[self.path[0]][1]))
        self.version.set_text(str(listStore[self.path[0]][2]))
        self.desc.set_text(str(listStore[self.path[0]][3]))
        self.infotxt = listStore[self.path[0]][5]
        if len(listStore[self.path[0]][4]) >= 1:
            depends = []
            for depend in listStore[self.path[0]][4] :
                absentdepend = True
                for title in listStore[self.path[0]][0] :
                    if depend == title :
                        absentdepend = False
                        break
                if absentdepend :
                    depends.append(_('%s MANQUANT')%depend)
                else :
                    depends.append(_('%s OK')%depend)
            self.depends.set_text(", ".join(depends))
        else:
            self.depends.set_text("-")

        #~ print "passage de le semsibilité de bt info : %s, pref : %s" %(listStore[self.path[0]][7]['info'],listStore[self.path[0]][7]['pref'])

        self.infoButton.set_sensitive(listStore[self.path[0]][7]['info'])
        self.prefButton.set_sensitive(listStore[self.path[0]][7]['pref'])



    #Quitter
    def on_Plugins_destroy(self,event=None):
        return True

    def on_cancel_clicked(self,event):
        self.gui.get_widget('plugins').destroy()
        return self.on_Plugins_destroy()

    #Afficher les informations sur le plugin
    def on_infoButton_clicked(self,truc):
        '''Ouvrir un fenetre permettant à l'auteur de faire une description
        de leur plugin'''
        boitedialogue = gtk.Dialog("Préférence du plugin d'exemple", None, 0, (gtk.STOCK_CLOSE,gtk.RESPONSE_OK))
        boitedialogue.set_size_request(560, 360)

        scrollwin = gtk.ScrolledWindow()
        scrollwin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        boitedialogue.vbox.pack_start(scrollwin, True, True, 0)
        scrollwin.show()

        etiquette = gtk.Label(self.infotxt)
        etiquette.set_use_markup(True)
        etiquette.set_line_wrap(True)
        etiquette.set_justify(gtk.JUSTIFY_FILL)
        scrollwin.add_with_viewport(etiquette)
        #~ scrollwin.vbox.pack_start(etiquette, True, True, 0)
        etiquette.show()

        boitedialogue.run()
        boitedialogue.destroy()


    def on_prefButton_clicked(self,button):
        '''ouvrir un fenêtre de selection de préférence du plugin'''
        from imp import load_source
        dir = self.listPlugins.store[self.path[0]][6]
        #~ pdb.set_trace()
        pathplug = os.path.join(os.environ['NOTECALC_DIR'],"plugins",dir,"main.py")
        plugin = load_source('main',pathplug)
        plugin.options()
        del plugin


    #Lancer un plugin
    def on_ok_clicked (self,truc=None):
        #pdb.set_trace()
        self.run(self.listPlugins.store[self.path[0]][6])

    def run(self,pluginname):
        from imp import load_source

        dicoCalc = []
        for (id, nameVar, entry, render, aff, precRes, res, unit, linkcalc, listVar, comm, type) in self.listCalc:
            dicoCalc.append({
                    'id':id,'nameVar':nameVar, 'entry':entry, 'render':render,
                    'aff': aff ,'precision':precRes, 'resultat': res, 'unit':unit,
                    'linkcalc':linkcalc, 'listVar':listVar, 'comment':comm, 'type':type
                })

        #~ self.on_Plugins_destroy()

        pathplug = os.path.join(os.environ['NOTECALC_DIR'],"plugins",pluginname,'main.py')

        plugin = load_source('main',pathplug)

        # barre d'activitée
        def progressStats(plugin):
            '''Par d'activitée du plugin'''
            #~ try :
            stats = plugin.get_stats()
            #~ except :
                #~ stats = {}

            if 'progress' in stats :
                if stats['progress'] == 'pulse' :
                    self.progressBar.pulse()
                else :
                    try :
                        progress = float(stats['progress'])
                        if progress <= 1 :
                            self.progressBar.set_fraction(progress)
                    except :
                        print "Warning : %s n'est pas un état de progression"%stats['progress']

            if 'label' in stats :
                self.progressLabel.set_markup(stats['label'])

            if 'hidden' in stats :
                if stats['hidden'] :
                    self.progressBox.hide()
                else :
                    self.progressBox.show()

            return True

        self.progressBox = gtk.Dialog(
                    title=pluginname, parent=None, flags=0, buttons=None
                )
        self.progressLabel = gtk.Label()
        self.progressLabel.set_text(pluginname)
        self.progressLabel.set_line_wrap(True)
        self.progressLabel.set_justify(gtk.JUSTIFY_FILL)

        self.progressBox.vbox.pack_start(self.progressLabel, True, True, 0)
        self.progressLabel.show()
        self.progressBar = gtk.ProgressBar()
        self.progressBox.vbox.pack_start(self.progressBar, True, True, 0)
        self.progressBar.show()
        self.progressBox.show()
        self.progressBar.pulse()
        self.progressBar.stats = gobject.timeout_add (100, progressStats,plugin)

        plugin.run(self.dicoInfo,dicoCalc)
        del plugin

        gobject.source_remove(self.progressBar.stats)
        self.progressBar.set_fraction(0.0)
        self.progressBox.destroy()


    #fermer description
    def on_info_delete_event(self,event=None,truc=None):
        self.infoWindow.hide()
        return True
    def on_closeInfoButton_clicked (self,truc):
        self.on_info_delete_event()



    ### FONCTIONS
    def loadPlugins(self):
        '''Explore le dossier des plugins, stock dans une liste leur nom,
        description ...'''
        listPlugins = []

        for dir in os.listdir(os.path.join(os.environ['NOTECALC_DIR'],"plugins")):
            '''Exploration des plugins root'''
            filedesc = os.path.join(os.environ['NOTECALC_DIR'],"plugins",dir,"desc.xml")
            if os.path.isfile(filedesc):
                depends = []
                button = {}
                try:
                    from xml.dom import minidom
                    xmldoc = minidom.parse(filedesc)
                    #print xmldoc.toxml()
                    name    = xmldoc.getElementsByTagName('name')   [0].firstChild.data.strip()
                    author  = xmldoc.getElementsByTagName('author') [0].firstChild.data.strip()
                    version = xmldoc.getElementsByTagName('version')[0].firstChild.data.strip()
                    desc    = xmldoc.getElementsByTagName('description')[0].firstChild.data.strip()
                    buttonNode = xmldoc.getElementsByTagName('active_button')[0]
                    if buttonNode.attributes['info'].value == "1":      button['info'] = True
                    else :                                              button['info'] = False
                    if buttonNode.attributes['options'].value == "1":   button['pref'] = True
                    else :                                              button['pref'] = False
                    try :
                        infotxt = xmldoc.getElementsByTagName('information')[0].firstChild.data
                    except :
                        infotxt = ""

                    depends = []
                    for depend in xmldoc.getElementsByTagName('depend'):
                        try :   depends.append(depend.firstChild.data)
                        except: pass
                except:
                    name    = _('Plugin invalide')
                    author  = '-'
                    version = '-'
                    desc    = _('Le fichier de description du plugin contenu dans "%s" est invalide')%dir
                    button['info'] = False
                    button['pref'] = False
                    infotxt = ""
#~
#~
                    #~ #print "plugin dans '%s' trouvé. \n - auteur : %s"%(dir,author)
                #except:
                    #desc = "Erreur lors du chargement du fichier de description"

                listPlugins.append((name,author,version,desc,depends,infotxt,dir,button))


        #idem avec rep plugin utilisateur (os.environ['HOME'])
        return listPlugins



class  listViewPlugins:
    '''Modèle pour la listview des plugins'''
    def modelName(self, tvcolumn, cell, model, iter):
        str = model.get_value(iter, 0)
        cell.set_property('text', str)
        return

    def on_Row_Select(self, modele, chemin, iter, donnees):
        print 'Row_Select : %s' % chemin

    def __init__(self, treeview):
        #global store #sais plus a koi ca sert

        self.list = treeview

        # Create the backend store
        self.store = gtk.ListStore(
            str,     # 0 # Nom
            str,     # 1 # Auteur
            str,     # 2 # Version
            str,     # 3 # Commentaire
            object,  # 4 # Liste des dépandances
            str,     # 5 # Information
            str,     # 6 # dossier du plugin
            object)  # 7 # button

        cellName = gtk.CellRendererText()
        #cellName.set_property('activatable', True)

        self.colName = gtk.TreeViewColumn('Liste des plugins')

        self.list.append_column(self.colName)

        # Pack CellRenderers
        self.colName.pack_start(cellName, True)

        self.colName.set_cell_data_func(cellName, self.modelName )

        self.list.set_model(self.store)
        return



if __name__ == '__main__':
    '''Pour les tester : dicos bidons'''
    from time import strftime

    dicoInfo = {
        'title': 'Titre',
        'description': 'blabla',
        'author': 'JF',
        'date' : strftime('%d/%m/%Y %H:%M')
        }
    content = [
    #  (ID,  entry, render, aff ,precRes, res,   unit, listVar, comm)
        (1,    2+2,    2+2,     2,    2,    4,     '',  ()     , "blabla"),
        (2,    2+7,    2+7,     2,    2,    9,     '',  ()     ,"blabla2")
        ]
    plugins = plugins(dicoInfo,content)
    gtk.main()


