##!/usr/bin/env python

import gtk, cairo, pango

settings = None

fen = gtk.Window()

def begin_print(operation, context):
    operation.set_n_pages(3)

def draw_page(operation, context, page_nr):
    print page_nr
    cr = context.get_cairo_context()

    if page_nr == 0:
        # image
        cr.set_source_pixbuf(gtk.gdk.pixbuf_new_from_file("logo.png"),0,0)
        cr.paint()
        cr.set_source_pixbuf(gtk.gdk.pixbuf_new_from_file("logo.png"),200,0)
        cr.paint()
    else :
        # Draw a red rectangle, as wide as the paper (inside the margins)
        cr.set_source_rgb(.9, .9, .9)
        cr.rectangle(0, 0, context.get_width(), 50)

        cr.fill()

        # Draw some lines
        cr.move_to(20, 10)
        cr.line_to(40, 20)
        cr.arc(60, 60, 20, 0,3)#M_PI)
        cr.line_to(80, 20)
        cr.line_to(200, 1800)

        cr.set_source_rgb(0, 0, 0)
        cr.set_line_width(5)
        cr.set_line_cap(cairo.LINE_CAP_ROUND)
        cr.set_line_join(cairo.LINE_JOIN_ROUND)

        cr.stroke()

        # Draw some text
        layout = context.create_pango_layout()
        layout.set_text("Hello <b>World</b><i>!</i> Printing is easy :\n %s"%page_nr)
        desc = pango.FontDescription("sans 28")
        layout.set_font_description(desc)

        cr.move_to(30, 20)
        cr.layout_path(layout)

        # Font Outline
        cr.set_source_rgb(0.93, 1.0, 0.47)
        cr.set_line_width(0.5)
        cr.stroke_preserve()

        # Font Fill
        cr.set_source_rgb(0, 0.0, 1.0)
        cr.fill()

        operation.set_n_pages(3)




po = gtk.PrintOperation()

po.connect("begin_print", begin_print)
po.connect("draw_page", draw_page)

fen.connect("destroy", gtk.main_quit)
fen.show_all()

res = po.run(gtk.PRINT_OPERATION_ACTION_PRINT_DIALOG, fen)

gtk.main()
